diff --git a/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassWriter.java b/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassWriter.java
index 4263632..64bde36 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassWriter.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassWriter.java
@@ -36,9 +36,11 @@ import javax.tools.JavaFileObject;
 import com.sun.tools.javac.code.*;
 import com.sun.tools.javac.code.Symbol.*;
 import com.sun.tools.javac.code.Type.*;
+import com.sun.tools.javac.tree.JCTree;
+import com.sun.tools.javac.tree.JCTree.*;
+import com.sun.tools.javac.tree.JCTree.Visitor;
 import com.sun.tools.javac.util.*;
 
-import static com.sun.tools.javac.code.BoundKind.*;
 import static com.sun.tools.javac.code.Flags.*;
 import static com.sun.tools.javac.code.Kinds.*;
 import static com.sun.tools.javac.code.TypeTags.*;
@@ -830,6 +832,124 @@ public class ClassWriter extends ClassFile {
         return vis;
     }
 
+    class TreeWriter extends Visitor {
+	public void visitArrayAccess(JCArrayAccess tree) {
+	    databuf.appendByte(ClassFile.TREE_ArrayAccess);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    tree.indexed.accept(this);
+	    tree.index.accept(this);
+	}
+
+	@Override
+	public void visitBinary(JCBinary tree) {
+	    databuf.appendByte(ClassFile.TREE_Binary);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    databuf.appendInt(tree.getTag());
+	    tree.getLeftOperand().accept(this);
+	    tree.getRightOperand().accept(this);
+	}
+
+	@Override
+	public void visitConditional(JCConditional tree) {
+	    databuf.appendByte(ClassFile.TREE_Conditional);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    tree.cond.accept(this);
+	    tree.truepart.accept(this);
+	    tree.falsepart.accept(this);
+	}
+
+	@Override
+	public void visitSelect(JCFieldAccess tree) {
+	    databuf.appendByte(ClassFile.TREE_FieldAccess);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    tree.selected.accept(this);
+	    databuf.appendChar(pool.put(tree.sym));
+	}
+
+	@Override
+	public void visitIdent(JCIdent tree) {
+	    databuf.appendByte(ClassFile.TREE_Ident);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    databuf.appendChar(pool.put(tree.sym));
+	}
+
+	public void visiTypeTest(JCInstanceOf tree) {
+	    databuf.appendByte(ClassFile.TREE_InstanceOf);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    tree.expr.accept(this);
+	    tree.clazz.accept(this);
+	}
+
+	@Override
+	public void visitLiteral(JCLiteral tree) {
+	    databuf.appendByte(ClassFile.TREE_Literal);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    databuf.appendChar(tree.typetag);
+	    databuf.appendChar(pool.put(tree.value));
+	}
+
+	@Override
+	public void visitApply(JCMethodInvocation tree) {
+	    databuf.appendByte(ClassFile.TREE_MethodInvocation);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    tree.meth.accept(this);
+	    writeTrees(tree.typeargs);
+	    writeTrees(tree.args);
+	}
+
+	@Override
+	public void visitNewArray(JCNewArray tree) {
+	    databuf.appendByte(ClassFile.TREE_NewArray);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    tree.elemtype.accept(this);
+	    writeTrees(tree.dims);
+	    writeTrees(tree.elems);
+	}
+
+	@Override
+	public void visitNewClass(JCNewClass tree) {
+	    assert (tree.getClassBody() == null);
+	    databuf.appendByte(ClassFile.TREE_NewClass);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    tree.encl.accept(this);
+	    writeTrees(tree.typeargs);
+	    tree.clazz.accept(this);
+	    writeTrees(tree.args);
+	}
+
+	@Override
+	public void visitTypeCast(JCTypeCast tree) {
+	    databuf.appendByte(ClassFile.TREE_TypeCast);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    tree.clazz.accept(this);
+	    tree.expr.accept(this);
+	}
+
+	@Override
+	public void visitUnary(JCUnary tree) {
+	    databuf.appendByte(ClassFile.TREE_Unary);
+	    databuf.appendChar(pool.put(typeSig(tree.type)));
+	    databuf.appendChar(tree.getTag());
+	    tree.arg.accept(this);
+	}
+
+	@Override
+	public void visitTree(JCTree tree) {
+	    throw new AssertionError(
+		    "Unexpected tree as an annotation argument: " + tree + " ("
+			    + tree.getClass() + ")");
+	}
+
+	private void writeTrees(List<JCExpression> exprs) {
+	    databuf.appendChar(exprs.size());
+	    for (JCExpression arg : exprs) {
+		arg.accept(this);
+	    }
+	}
+    }
+
+    private Visitor treeWriter = new TreeWriter();
+	
     /** A visitor to write an attribute including its leading
      *  single-character marker.
      */
@@ -894,6 +1014,10 @@ public class ClassWriter extends ClassFile {
                 a.accept(this);
             }
         }
+        public void visitExpression(Attribute.Expression expr) {
+	    databuf.appendByte('E');
+	    expr.getValue().accept(treeWriter);
+	}
     }
     AttributeWriter awriter = new AttributeWriter();
 
@@ -1361,7 +1485,8 @@ public class ClassWriter extends ClassFile {
             SameFrame(int offsetDelta) {
                 this.offsetDelta = offsetDelta;
             }
-            int getFrameType() {
+            @Override
+	    int getFrameType() {
                 return (offsetDelta < SAME_FRAME_SIZE) ? offsetDelta : SAME_FRAME_EXTENDED;
             }
             @Override
@@ -1383,7 +1508,8 @@ public class ClassWriter extends ClassFile {
                 this.offsetDelta = offsetDelta;
                 this.stack = stack;
             }
-            int getFrameType() {
+            @Override
+	    int getFrameType() {
                 return (offsetDelta < SAME_FRAME_SIZE) ?
                        (SAME_FRAME_SIZE + offsetDelta) :
                        SAME_LOCALS_1_STACK_ITEM_EXTENDED;
@@ -1411,7 +1537,8 @@ public class ClassWriter extends ClassFile {
                 this.frameType = frameType;
                 this.offsetDelta = offsetDelta;
             }
-            int getFrameType() { return frameType; }
+            @Override
+	    int getFrameType() { return frameType; }
             @Override
             void write(ClassWriter writer) {
                 super.write(writer);
@@ -1431,7 +1558,8 @@ public class ClassWriter extends ClassFile {
                 this.offsetDelta = offsetDelta;
                 this.locals = locals;
             }
-            int getFrameType() { return frameType; }
+            @Override
+	    int getFrameType() { return frameType; }
             @Override
             void write(ClassWriter writer) {
                 super.write(writer);
@@ -1455,7 +1583,8 @@ public class ClassWriter extends ClassFile {
                 this.locals = locals;
                 this.stack = stack;
             }
-            int getFrameType() { return FULL_FRAME; }
+            @Override
+	    int getFrameType() { return FULL_FRAME; }
             @Override
             void write(ClassWriter writer) {
                 super.write(writer);
diff --git a/langtools/src/share/classes/com/sun/tools/javac/model/AnnotationProxyMaker.java b/langtools/src/share/classes/com/sun/tools/javac/model/AnnotationProxyMaker.java
index acd6d99..62b7516 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/model/AnnotationProxyMaker.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/model/AnnotationProxyMaker.java
@@ -240,7 +240,11 @@ public class AnnotationProxyMaker {
             }
         }
 
-        public void visitError(Attribute.Error e) {
+	public void visitExpression(Attribute.Expression e) {
+	    value = null;
+	}
+
+	public void visitError(Attribute.Error e) {
             value = null;       // indicates a type mismatch
         }
 
@@ -251,9 +255,11 @@ public class AnnotationProxyMaker {
         private void typeMismatch(final Method method, final Attribute attr) {
             value = new ExceptionProxy() {
                 static final long serialVersionUID = 269;
+                @Override
                 public String toString() {
                     return "<error>";   // eg:  @Anno(value=<error>)
                 }
+                @Override
                 protected RuntimeException generateException() {
                     return new AnnotationTypeMismatchException(method,
                                 attr.type.toString());
@@ -279,20 +285,24 @@ public class AnnotationProxyMaker {
             typeString = t.toString();
         }
 
+        @Override
         public String toString() {
             return typeString;
         }
 
+        @Override
         public int hashCode() {
             return (type != null ? type : typeString).hashCode();
         }
 
+        @Override
         public boolean equals(Object obj) {
             return type != null &&
                    obj instanceof MirroredTypeExceptionProxy &&
                    type.equals(((MirroredTypeExceptionProxy) obj).type);
         }
 
+        @Override
         protected RuntimeException generateException() {
             return new MirroredTypeException(type);
         }
@@ -315,14 +325,17 @@ public class AnnotationProxyMaker {
             typeStrings = ts.toString();
         }
 
+        @Override
         public String toString() {
             return typeStrings;
         }
 
+        @Override
         public int hashCode() {
             return (types != null ? types : typeStrings).hashCode();
         }
 
+        @Override
         public boolean equals(Object obj) {
             return types != null &&
                    obj instanceof MirroredTypesExceptionProxy &&
@@ -330,6 +343,7 @@ public class AnnotationProxyMaker {
                       ((MirroredTypesExceptionProxy) obj).types);
         }
 
+        @Override
         protected RuntimeException generateException() {
             return new MirroredTypesException(types);
         }
diff --git a/langtools/src/share/classes/com/sun/tools/javac/model/JavacElements.java b/langtools/src/share/classes/com/sun/tools/javac/model/JavacElements.java
index 7d233d5..182e9be 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/model/JavacElements.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/model/JavacElements.java
@@ -224,16 +224,20 @@ public class JavacElements implements Elements {
         Symbol sym = cast(Symbol.class, e);
         class Vis extends JCTree.Visitor {
             List<JCAnnotation> result = null;
-            public void visitTopLevel(JCCompilationUnit tree) {
+            @Override
+	    public void visitTopLevel(JCCompilationUnit tree) {
                 result = tree.packageAnnotations;
             }
-            public void visitClassDef(JCClassDecl tree) {
+            @Override
+	    public void visitClassDef(JCClassDecl tree) {
                 result = tree.mods.annotations;
             }
-            public void visitMethodDef(JCMethodDecl tree) {
+            @Override
+	    public void visitMethodDef(JCMethodDecl tree) {
                 result = tree.mods.annotations;
             }
-            public void visitVarDef(JCVariableDecl tree) {
+            @Override
+	    public void visitVarDef(JCVariableDecl tree) {
                 result = tree.mods.annotations;
             }
         }
@@ -308,6 +312,8 @@ public class JavacElements implements Elements {
             }
             public void visitEnum(Attribute.Enum e) {
             }
+            public void visitExpression(Attribute.Expression e) {
+            }
             public void visitError(Attribute.Error e) {
             }
         }
@@ -324,15 +330,18 @@ public class JavacElements implements Elements {
                                        final JCTree tree) {
         class TS extends TreeScanner {
             JCExpression result = null;
-            public void scan(JCTree t) {
+            @Override
+	    public void scan(JCTree t) {
                 if (t != null && result == null)
                     t.accept(this);
             }
-            public void visitAnnotation(JCAnnotation t) {
+            @Override
+	    public void visitAnnotation(JCAnnotation t) {
                 if (t == tree)
                     scan(t.args);
             }
-            public void visitAssign(JCAssign t) {
+            @Override
+	    public void visitAssign(JCAssign t) {
                 if (t.lhs.getTag() == JCTree.IDENT) {
                     JCIdent ident = (JCIdent) t.lhs;
                     if (ident.sym == sym)
diff --git a/langtools/src/share/classes/com/sun/tools/javac/tree/TreeMaker.java b/langtools/src/share/classes/com/sun/tools/javac/tree/TreeMaker.java
index b48841d..73d19ea 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/tree/TreeMaker.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/tree/TreeMaker.java
@@ -749,6 +749,9 @@ public class TreeMaker implements JCTree.Factory {
         public void visitEnum(Attribute.Enum e) {
             result = QualIdent(e.value);
         }
+        public void visitExpression(Attribute.Expression e) {
+            result =  e.getValue();
+        }
         public void visitError(Attribute.Error e) {
             result = Erroneous();
         }
diff --git a/langtools/src/share/classes/com/sun/tools/javadoc/AnnotationValueImpl.java b/langtools/src/share/classes/com/sun/tools/javadoc/AnnotationValueImpl.java
index 0251512..559f18d 100644
--- a/langtools/src/share/classes/com/sun/tools/javadoc/AnnotationValueImpl.java
+++ b/langtools/src/share/classes/com/sun/tools/javadoc/AnnotationValueImpl.java
@@ -102,6 +102,10 @@ public class AnnotationValueImpl implements AnnotationValue {
             }
             value = vals;
         }
+        
+        public void visitExpression(Attribute.Expression e) {
+            value = e;
+        }
 
         public void visitError(Attribute.Error e) {
             value = "<error>";
@@ -114,6 +118,7 @@ public class AnnotationValueImpl implements AnnotationValue {
      * @return the text of a Java language annotation value expression
      *          whose value is the value of this annotation type element.
      */
+    @Override
     public String toString() {
         ToStringVisitor tv = new ToStringVisitor();
         attr.accept(tv);
@@ -123,7 +128,8 @@ public class AnnotationValueImpl implements AnnotationValue {
     private class ToStringVisitor implements Attribute.Visitor {
         private final StringBuffer sb = new StringBuffer();
 
-        public String toString() {
+        @Override
+	public String toString() {
             return sb.toString();
         }
 
@@ -164,6 +170,10 @@ public class AnnotationValueImpl implements AnnotationValue {
             // Omit braces from singleton.
             if (a.values.length != 1) sb.append('}');
         }
+        
+        public void visitExpression(Attribute.Expression e) {
+            sb.append(e);
+        }
 
         public void visitError(Attribute.Error e) {
             sb.append("<error>");
diff --git a/langtools/src/share/classes/java/lang/annotation/AllowNonConstant.java b/langtools/src/share/classes/java/lang/annotation/AllowNonConstant.java
new file mode 100644
index 0000000..1425446
--- /dev/null
+++ b/langtools/src/share/classes/java/lang/annotation/AllowNonConstant.java
@@ -0,0 +1,9 @@
+package java.lang.annotation;
+
+/**
+ * This annotation can be applied to a method within an annotation definition.
+ * It means that when that annotation is used, a non-constant value is allowed
+ * to be supplied for that method.
+ */
+public @interface AllowNonConstant {
+}
diff --git a/langtools/src/share/classes/javax/lang/model/element/AnnotationValue.java b/langtools/src/share/classes/javax/lang/model/element/AnnotationValue.java
index 9447af4..cb1fd4a 100644
--- a/langtools/src/share/classes/javax/lang/model/element/AnnotationValue.java
+++ b/langtools/src/share/classes/javax/lang/model/element/AnnotationValue.java
@@ -26,8 +26,6 @@
 package javax.lang.model.element;
 
 
-import java.util.List;
-import javax.lang.model.type.*;
 
 /**
  * Represents a value of an annotation type element.
@@ -39,6 +37,7 @@ import javax.lang.model.type.*;
  *     <li> {@code AnnotationMirror}
  *     <li> {@code List<? extends AnnotationValue>}
  *              (representing the elements, in declared order, if the value is an array)
+ *     <li> {@code ExpressionTree} (representing a general expression)
  * </ul>
  *
  * @author Joseph D. Darcy
